{$A+,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }

(*****************************************************)
(*           COMMANDES DE GESTION STRING             *)
(*                   STRINGER V1.1                   *)
(*****************************************************)
unit stringer;

interface

procedure KillData(var texte : string; data : byte);
procedure ChangeData(var texte : string; dataSource, dataNew : byte);
procedure Tronque(var texte : string; max : byte);
procedure UpCaseStr(var texte : string);
function  CompStr(var texte1,texte2 : string; up : boolean) : integer;
function  EgalMem(var x1, x2; lg : word) : boolean;
function  FillString(long: word; data : byte) : string;
function  CentralPos(longtexte,long : byte):byte;
function  CentreString(texte : string; long,data : byte) : string;

implementation

(**************** TRAVAUX SUR STRING OU SIMILAIRE *************)

(*$L STRKIT.OBJ *)
procedure UpCaseStr(var texte : string); external;
function CompStr(var texte1,texte2 : string; up : boolean):integer; external;
function EgalMem(var x1, x2; lg : word) : boolean; external;

procedure KillData(var texte : string; data : byte);
var index : word;
begin
  index := 1;
  while (index<=length(texte)) do
    if texte[index] = char(data) then
      begin
        move(texte[index+1],texte[index],length(texte)-index);
        dec(texte[0]);
      end
    else Inc(index);
end;

procedure ChangeData(var texte : string; dataSource, dataNew : byte);
var index : word;
begin
  for index := 1 to length(texte) do
    if texte[index] = char(dataSource) then texte[index] := char(dataNew);
end;

procedure Tronque(var texte : string; max : byte);
begin
  if byte(texte[0])>max then texte[0] := char(max);
end;

function FillString(long: word; data : byte) : string;
var buf : string;
begin
  FillChar(buf[1],long,data);
  buf[0] := char(long);
  FillString := buf;
end;

function CentralPos(longtexte,long : byte):byte;
begin
  CentralPos := ((long-Longtexte) shr 1)+1;
end;

function CentreString(texte : string; long,data : byte) : string;
var buf   : string;
begin
  buf := FillString(long,data);
  Tronque(texte,long);
  move(texte[1],buf[CentralPos(byte(texte[0]),long)],word(texte[0]));
  CentreString := buf;
end;

end.
