{********************************
 *                              *
 *       C M P   T O O L S      *
 *                              *
 ********************************}


(*
Procedure AffNbCodes;
var buf : string[5];
Begin
 WrtScr(FillString(18,32),61,4+2,CNet);
 If cM^.NbCodes<>$FFFF Then
  begin
   str(cM^.NbCodes:5,buf);
   WrtScr(buf+'c',72,4+2,CNet);
   str((cM^.NbCodes/120):5:1,buf);
   WrtScr(buf+'s',62,4+2,CNet);
  end;
End;
*)

Procedure AffNbCodes;
Var Buf : String[18];
    z   : String[10];
    t   : Real;
    sgn : Char;
Begin
 If cM^.ValidCodes Then
  Begin
   t  := Round((cM^.TotalCodes)*(TabSpeed[Cfg.Reel].BD/1152))/10;
   If t>=100 Then Str(t:4:0,Buf) Else Str(t:4:1,Buf);
   Str(cM^.TotalCodes:5,z);
   Buf := Buf+'s '+z+'c ';

   If cM^.DiffCodes>0 Then sgn := '+'
   Else
    If cM^.DiffCodes<0 Then sgn := '-'
    Else sgn := ' ';

   If Abs(cM^.DiffCodes)>=10000 Then z := '****'
   Else
    Begin
     Str(Abs(cM^.DiffCodes),z);
    End;
   Buf := Buf+FillString(4-Length(z),32)+sgn+z;

   WrtScr(Buf,61,4+2,CNet);
  End
 Else WrtScr(FillString(18,32),61,4+2,CNet);
End;


(*
Procedure AffNbCodes;
var buf : string[5];
Begin
 If cM^.NbCodes<>$FFFF Then
  begin
   WrtScr(FillString(18,32),61,4,SurEvidenceField);
   str(cM^.NbCodes:5,buf);
   WrtScr(buf+'c',72,4,CMiNet);
   str((cM^.NbCodes/120):5:1,buf);
   WrtScr(buf+'s',62,4,CMiNet);
  end
 Else WrtScr(FillString(18,32),61,4,SurEvidenceField);
End;
*)
(*
function Actif(colonne, ligne: byte) : boolean;
begin
  Actif := (colonne>=PXhaut) and (colonne<=PXbas) and
           (ligne>=PYhaut) and (ligne<=PYbas);
end;
*)

procedure AffLnShow( iY : Byte );
var iX : Byte;
    c  : VDispRamEl;
begin
 for iX := 0 to ScreenLong-1 do
   begin
     c := cM^.Ram[iY,iX];
     AffVdtChar(c.Car,iX,iY,c.Att);
  end;
end;


procedure AffAllLnShow( Var Ram : VDispRam; LZ, Actif : Boolean );
var iY : Byte;
    iX : Byte;
    c  : VDispRamEl;
    deb : Byte;
begin
 If LZ Then deb := 0 Else deb := 1;
 for iY := deb to ScreenHigh-1 do
  for iX := 0 to ScreenLong-1 do
    begin
      c := Ram[iY,iX];
      If Actif Then AffVdtChar(c.Car,iX,iY,c.Att)
      Else _AffVdtChar(c.Car,iX,iY,c.Att);
   end;
end;


Procedure ZipTabUndo( nMem : Byte; nSerie : Longint );
Var iRead : Word;
    iWrite: Word;
    Nb    : Word;
    i     : Word;
    u, x  : PUndoRec;
Begin
 iRead := UndoRead;
 iWrite:= iRead;
 Nb    := 0;
 i     := 0;
 While i<UndoNb Do
  Begin
   u := TabUndo[iRead];
   If (u^.Ready) And ((u^.nMem<>nMem) Or (u^.nSerie<nSerie)) Then
    Begin
     x := TabUndo[iWrite];
     TabUndo[iWrite] := u;
     TabUndo[iRead] := x;
     Inc(iWrite);
     If iWrite>=Cfg.NbreUndo Then iWrite := 0;
     Inc(Nb);
    End;
   Inc(iRead);
   If iRead>=Cfg.NbreUndo Then iRead := 0;
   Inc(i);
  End;
 UndoNb    := Nb;
 UndoWrite := iWrite;
End;


Procedure KeepThisLine( nMem, nLn : Byte; nSerie : Longint; Var Line : VDispRamLine );
Var u : PUndoRec;
Begin
 If UndoNb=Cfg.NbreUndo Then
  Begin { c'est plein !!! liminer LE dernier lment }
   u := TabUndo[UndoRead];
   u^.Ready := FALSE;
   Inc(UndoRead);
   If UndoRead>=Cfg.NbreUndo Then UndoRead := 0;
   Dec(UndoNb);
  End;

 u := TabUndo[UndoWrite];
 u^.nMem   := nMem;
 u^.nLn    := nLn;
 u^.nSerie := nSerie;
 u^.Ready  := TRUE;
 u^.Line   := Line;
 Inc(UndoWrite);
 If UndoWrite>=Cfg.NbreUndo Then UndoWrite := 0;
 Inc(UndoNb);
End;


Procedure KeepMem( nMem, y, ht : Byte );
Var M : PMemPg_Rec;
    i : Byte;
Begin
 If ht>0 Then
  Begin
   M := TabMem[nMem];

   If M^.UndoSerie>M^.ReadSerie Then
    Begin
     ZipTabUndo(nMem,M^.ReadSerie);
     M^.UndoSerie := M^.ReadSerie;
    End;

   i := 0;
   While i<ht Do
    Begin
     KeepThisLine( nMem, y+i, M^.UndoSerie, M^.Ram[y+i] );
     Inc(i);
    End;

   Inc(M^.UndoSerie);
   M^.ReadSerie := M^.UndoSerie;

   If nMem=NumPage Then
    Begin
     CompoChg(y,ht);
    End
   Else
    Begin
     MemChange(M^);
    End;
  End;
End;


{ Induit automatiquement un raffraichissement ! }
{ renvoi FALSE si rien ! }


Function  FindUndoMem( Undo : Boolean ) : Boolean;
Var i  : Word;
    u  : PUndoRec;
    ht : Byte;
    iR : Word;
    r  : VDispRamLine;
    us : Longint;
Begin
 i  := UndoNb;
 iR := UndoRead;
 ht := 0;
 us := cM^.ReadSerie;
 If Undo Then Dec(us);
 While i>0 Do
  Begin
   Dec(i);
   u := TabUndo[iR];
   If (u^.Ready) And (u^.nMem=NumPage) And
      (u^.nSerie=us) Then
    Begin
     Inc(ht);

     r := cM^.Ram[u^.nLn];
     cM^.Ram[u^.nLn] := u^.Line;
     u^.Line := r;
     LnRAff(u^.nLn);
     If u^.nLn>0 Then AffLnShow(u^.nLn);
    End
   Else
    If (ht>0) Then i := 0; { Forcer la fin }
   Inc(iR);
   If iR>=Cfg.NbreUndo Then iR := 0;
  End;

 If ht>0 Then
  Begin
   If Not(Undo) Then Inc(us);
   cM^.ReadSerie := us;
   MemChange(cM^);
   FindUndoMem := TRUE;
  End
 Else FindUndoMem := FALSE;
End;



Function  UndoMem : Boolean;
Begin
 UndoMem := FindUndoMem(TRUE);
End;

Function  UnUndoMem : Boolean;
Begin
 UnUndoMem := FindUndoMem(FALSE);
End;


Procedure SwapDRCSActif;
Begin
 If DRCSActif Then
  Begin
   DRCSActif := FALSE;
   FieldAspect(FieldDRCS,CDisp);
  End
 Else
  Begin
   DRCSActif := TRUE;
   FieldAspect(FieldDRCS,SurEvidenceField);
  End;
End;


Procedure SwapExtG1;
Begin
 ExtG1 := Not(ExtG1);
 AffExtG1;
End;


function MemTexte( NumPage : word ) : string;
var buf : string[2];
begin
  if NumPage<=10 then MemTexte := 'MEM.'+char(47+NumPage)
  else
    begin
      str(NumPage-1:2,buf);
      memTexte := 'MEM.'+buf;
    end;
end;

procedure GoXY (x,y:byte);
var reg : registers;
begin
  reg.ax := 4;
  reg.cx := (x+20)*8+4;
  reg.dx := (y)*8+4;
  IntMouse(reg);
end;

function CurseurMove ( debord : boolean ) : boolean;

var x,y : ShortInt;

begin
  x:= CurX; { 0-39 }
  y:= CurY; { 1-24 }
  if FUNCT then
    begin
      case Key of
        #72 : dec(y);
        #80 : inc(y);
        #75 : dec(x);
        #77 : inc(x);
        #71 : begin
                dec(x);
                dec(y);
              end;
        #73 : begin
                inc(x);
                dec(y);
              end;
        #81 : begin
                inc(x);
                inc(y);
              end;
        #79 : begin
                dec(x);
                inc(y);
              end;
        #15 : if x mod TABULATION=0 then dec(x,TABULATION)
              else dec(x, x mod TABULATION);
      else
        begin
          CurseurMove:=false;
          exit;
        end;
      end;
    end
  else
    begin
      case Key of
        #9  : if x mod TABULATION=0 then inc(x,TABULATION)
              else x := (x div TABULATION)*TABULATION+TABULATION;
        #13 : begin { return }
               x := PXhaut;
               Inc(y);
              end;
      else
        begin
          CurseurMove:=false;
          exit;
        end;
      end;
    end;
  if x<PXhaut then
    if debord then
      begin
        x:=PXbas;
        if CurY=y then dec(y);
      end
    else x:=PXhaut;
  if x>PXbas then
    if debord then
      begin
        x:=PXhaut;
        if CurY=y then inc(y);
      end
    else  x:=PXbas;
  if y<PYhaut then
    if debord then y:=PYbas
    else y:=PYhaut;
  if y>PYbas then
    if debord then y:=PYhaut
    else y:=PYbas;
  CurseurMove:=true;
  CurX := x;
  CurY := y;
  { positionne la souris }
  GoXY(CurX,CurY);
end;

function ConvertPC : boolean;
{ il sagit d'une conversion de fond et non de forme }
{ les valeurs de certainnes touches sont transforme }
var index : byte;
begin
  for index:=0 to ConvertLong do
    if PC_Compo[index,0]=byte(key) then
      begin
        KeyCompo := char(PC_Compo[index,1]);
        ConvertPC := true;
        exit;
      end;
  ConvertPC := false;
end;

function PCKeyData( DRCSKey : Boolean ) : boolean;
{ en sortie KeyCompo contient la traduction, ou plutot le code qui }
{ sera place dans la RAM Compo. si la fonction retourne FALSE alors}
{ la traduction n'est pas effectue: touche non traduisible }
begin
  KeyCompo := #0;

  If Not(Funct) And DRCSKey And (Key>=#$20) And (Key<=#$7F) Then
   Begin
    KeyCompo := Key;
    PCKeyData := TRUE;
   End
  Else
   Begin
    if FUNCT then
      if (CTRL and 4)=0 then
        begin { la touche CTRL n'est pas enfonce }
              { donc on a uniquement ALT+KEY }
          if ((Key>=#123) and (Key<=#126)) or (Key=#128) then KeyCompo := Key
          else
            if not(ConvertPC) then
              begin
                PCKeyData := false;
                exit;
              end;
        end
      else
        begin { CTRL est enfonce }
          PCKeyData := false;
          exit;
        end
    else { FUNCT = FALSE }
      if not(Key in Touche_Ens) then
        begin
          PCKeyData := false;
          exit;
        end
      else
        KeyCompo := Key;

    If Not(DRCSKey) Then
     Begin
      { traduction sur la forme, c-a-d qu'on propose un caractere dont la }
      { la forme est proche de celle sur minitel }
      case KeyCompo of
        #96  : KeyCompo := #196;
        #124 : KeyCompo := #179;
      end;
      PCKeyData := true;
     End
    Else
     Begin
      PCKeyData := (KeyCompo>=#$20) And (KeyCompo<=#$7F);
     End;
   End;
end;

procedure AffShow;
var buf_texte : string[7];
    iY : Byte;
begin
  for iY := 1 to ScreenHigh-1 do AffLnShow(iY);

  if NumPage = 0 then buf_texte := ' MNTL. '
  else
    begin
      buf_texte := MemTexte(NumPage)+' ';
      if length(buf_texte)<7 then buf_texte := ' '+buf_texte;
    end;
  WrtScr(buf_texte,61,1,CNet);
  AffUnderDisk(cM^);
end;


procedure IncMem;
begin
 StopRAff;

 Inc(NumPage);
 if NumPage>CFG.NbreMem then NumPage:= 1; { et non 0 }
 cM := TabMem[NumPage];

 RAffSmallMenu;
 AffShow;

 If Cfg.GlobalRAff Then
  Begin
   BackRefresh;
   GlobalRefresh;
   ReportRAff(8);
   ReadyForRAff;
  End;

 ExCurY := ScreenHigh;
end;


procedure DecMem;
begin
 StopRAff;

 Dec(NumPage);
 if NumPage<1 then NumPage:= CFG.NbreMem; { et non 0 }
 cM := TabMem[NumPage];

 RAffSmallMenu;
 AffShow;

 If Cfg.GlobalRAff Then
  Begin
   BackRefresh;
   GlobalRefresh;
   ReportRAff(8);
   ReadyForRAff;
  End;

 ExCurY := ScreenHigh;
end;


procedure IncAttAff( att : byte);
begin
  if ReadAtt(PB.Panel,att)>=bit_att[att].Long then WrtAtt(PB.Panel,att,0)
  else WrtAtt(PB.Panel,att,ReadAtt(PB.Panel,att)+1);
  AffAtt(PB.Panel,att);
end;

procedure DecAttAff( att : byte);
begin
  if ReadAtt(PB.Panel,att)=0 then WrtAtt(PB.Panel,att,bit_att[att].Long)
  else WrtAtt(PB.Panel,att,ReadAtt(PB.Panel,att)-1);
  AffAtt(PB.Panel,att);
end;

procedure InvActif;
var i : word;
begin
  for i := 0 to NbreAtt-1 do
    begin
      AttActif[i]:= not(AttActif[i]);
      AffAtt(PB.Panel,i);
    end;
end;

procedure AllActif;
var i : word;
begin
  for i := 0 to NbreAtt-1 do
    begin
      AttActif[i]:= TRUE;
      AffAtt(PB.Panel,i);
    end;
end;

function PanelCMD : boolean;
var n : word;
begin
  if not(FUNCT) then
    begin
      PanelCMD := false;
      exit;
    end
  else
    begin
      case Key of
        #32      : Begin { Alt+D active/desactive DRCS }
                    SwapDRCSActif;
                   End;

        '?'..'D' : { F5..F10 definition du graphisme }
                   begin
                     PB.Graphik := PB.Graphik xor (1 shl(byte(key)-63));
                     AffGra;
                   end;
        #84,#86,#88 : { SHIFT F1,F3,F5  Incremente attribut }
                      IncAttAff((byte(key)-84) div 2);
        #85,#87,#89 : { SHIFT F2,F4,F6  Decremente attribut }
                      DecAttAff((byte(key)-85) div 2);
        #90..#93    : { SHIFT F7,F8,F9,F10 }
                      IncAttAff(byte(key)-87);
        #98 : InvActif; { ctrl F5 : inverse l'activit }
        #99 : AllActif; { ctrl F6 : active tous les attributs }
        #100 : { ctrl F7  inverse graphisme }
               begin
                 PB.Graphik := PB.Graphik xor 63;
                 AffGra;
               end;
        #101 : { ctrl F8  efface le graphisme }
               begin
                 PB.Graphik := 0;
                 AffGra;
               end;
        #104..#109 :
               begin
                 n := (byte(Key)-104) div 2;
                 AttActif[n] := not AttActif[n];
                 AffAtt(PB.Panel,n);
               end;
        #110..#113 :
               begin
                 n := byte(Key)-110+3;
                 AttActif[n] := not AttActif[n];
                 AffAtt(PB.Panel,n);
               end;
      else
        begin
          PanelCMD := false;
          exit;
        end;
      end;
      PanelCMD := true;
    end;
end;

function CorrigeAtt(Data : byte; Att : word; x,y: byte):Word;
{ corrige l'attribut qui va etre place en memoire en fonction }
{ de la situation du curseur, du caractere actif/inactif des  }
{ des attributs du panel. l'att du panel indique deja si c'est}
{ un attribut texte ou graphik }
{ la fonction retourne l'attribut corrige }
var ScrAtt : word;
    index : byte;
begin
  ScrAtt := TakeAttRam(x,y); { on prend l'att memoire-ecran }
  { les att inactif prennent la valeur a l'ecran }
  for index:= 0 to NbreAtt-1 do
    if not(AttActif[index]) then WrtAtt(Att,index,ReadAtt(ScrAtt,index));
  if (Att and Graphik)=0 then
    begin { texte }
      if y<(PYhaut+1) then Att := Att And Not(Taille_Haute); { plus de hauteur }
      if x>(PXbas-1) then Att := Att And Not(Taille_Large); { plus de largeur }
    end
  else Att := Att And Not(Inverse+Taille);

  If Not(DRCSChar(Char(Data),Att)) Then Att := Att And Not(DRCS);

  Att := Att And Not(AttBitUnused+Delim);

  CorrigeAtt := Att;
end;

procedure AffData(Data : byte; Att : Word; x,y : byte);
{ les att doivent etre corriges, il y a simulation elementaire }
{ a l'ecran }
begin
  AffVdtChar(Char(Data),x,y,Att);
  if ((Att and Graphik)=0) And (Data<>Complement) then
   begin
     if (Att and 64)<>0 then
       begin { double hauteur (au moins) }
         AffVdtChar(Char(Complement),x,y-1,Att);
         if (Att and 128)<>0 then AffVdtChar(Char(Complement),x+1,y-1,Att);
       end;
     if (Att and 128)<>0 then AffVdtChar(Char(Complement),x+1,y,Att);
   end;
end;

procedure DataToShow(_Data : byte; _Att : word; x,y : byte);
begin
  if ((_Att and Graphik)=0) and (_Data<>Complement) then
    begin
      if (_Att and 64)<>0 then
        begin
          KeepMem(NumPage,y-1,2);

          with cM^.Ram[y-1,x] do
            begin
              Car := Char(Complement);
              att := _Att;
            end;
          if (_Att and 128)<>0 then
            with cM^.Ram[y-1,x+1] do
              begin
                Car  := Char(Complement);
                att  := _Att;
              end;
        end
      Else KeepMem(NumPage,y,1);

      if (_Att and 128)<>0 then
        with cM^.Ram[y,x+1] do
          begin
            Car  := Char(Complement);
            att  := _Att;
          end;
    end
  Else KeepMem(NumPage,y,1);

  with cM^.Ram[y,x] do
    begin
      Car := Char(_Data);
      att := _Att;
    end;
end;

procedure SimpleNextPos(var x,y: byte);
begin
  inc(x);
  if x>PXbas then
    begin
      x:=PXhaut;
      inc(y);
      if y>PYbas then y:=PYhaut;
    end;
end;

procedure NextPos(Data : byte; Att : Word; var x,y : byte);
{ les limites sont donnes par PXhaut,PYhaut... }
{ Ne marche pas pour un ecran en 'rouleau' }
{ Attention : X et Y modifier en sortie! }
begin
  if ((Att and Graphik)=0) and (Data<>Complement) then
    begin
      inc(x);
      if (Att and 128)<>0 then x:=x+1; { Large }
      if x>PXbas then
        begin
          x:=PXhaut;
          inc(y);
          if y>PYbas then y:=PYhaut;
          if (att and 64)<>0 then
            begin { haut }
              inc(y);
              if y>PYbas then
                begin
                  y:=PYhaut+1;
                  if y>PYbas then y:=PYhaut;
                end;
            end;
        end;
    end
  else
    SimpleNextPos(x,y); { graphik ou complement }
end;

procedure DataToMntl(Data : byte; Att : Word; x,y : byte);
var code : VdtString;
begin
  Mntl.Write(#31+char(y+64)+char(x+65)+#17);

  If Att And Graphik<>0 Then Mntl.Write(#14);

  { trait }
  if (Att and Trait)<>7 then Mntl.Write(char(27)+char(64+couleur[ReadAtt(Att,0)]));
  { stable }
  if (Att and Stable)=0 then Mntl.Write(char(27)+char(72));
  if (Att and Graphik)=0 then
    begin { texte }
      { inverse }
      if (Att And Inverse)<>0 then Mntl.Write(char(27)+char(93));
      if Data=32 then
        begin
          { fond }
          Mntl.Write(char(27)+char(80+couleur[ReadAtt(Att,1)]));
          { souligne }
          Mntl.Write(char(27)+char(89+ReadAtt(Att,5)));
        end;
    end
  else
    begin { graphik }
      { fond }
      if (Att and Fond)<>0 then Mntl.Write(char(27)+char(80+couleur[ReadAtt(Att,1)]));
      { disjoint }
      if (Att and Disjoint)<>0 then Mntl.Write(char(27)+char(90));
    end;


  if (Att and Graphik)=0 then
    begin
      if data<>Complement then
        begin
          if (Att and Taille)<>0 then Mntl.Write(char(27)+char(76+ReadAtt(Att,2)));
          { la taille est anormale }

          If Att And DRCS<>0 Then Mntl.Write(ActG0Prm);

          TradDataMntl(char(data),code);
          Mntl.Write(code);

          If Att And DRCS<>0 Then Mntl.Write(ActG0Std);
        end;
    end
  else
    begin
      If Att And DRCS<>0 Then Mntl.Write(ActG1Prm);
      { data evolue deja entre 32 et 95 }
      Mntl.Write(char(GraphCorrector(Data)));
      If Att And DRCS<>0 Then Mntl.Write(ActG1Std);
    end;
end;



Function  GetPanel : Word;
Var Att : Word;
Begin
 Att := PB.Panel And Not(Graphik+AttBitUnused+DRCS+Delim);
 GetPanel := Att;
End;


Function  GetPanelCar : Word;
Var Att : Word;
Begin
 Att := GetPanel;

 If DRCSActif Then Att := Att Or DRCS
 Else Att := Att And Not(DRCS);

 GetPanelCar := Att;
End;


procedure PutCar (Data : byte; Att : Word; x,y : byte);
begin
 Att := CorrigeAtt(Data,Att,x,y);

 AffData(Data,Att,x,y);
 DataToShow(Data,Att,x,y);
 DataToMntl(Data,Att,x,y);
end;


procedure GereCar (Data : byte; Att : Word; Dlm : Boolean; var x,y : byte);
begin
  Att := CorrigeAtt(Data,Att,x,y);

  If Dlm And (Data=32) Then Att := Att Or Delim;

  AffData(Data,Att,x,y);
  DataToShow(Data,Att,x,y);
  DataToMntl(Data,Att,x,y);

  NextPos(Data,Att,x,y);
  GoXY(x,y);
  if (PXhaut=PXbas) and (PYhaut=PYbas) then
    Mntl.Write(#31+char(y+64)+char(x+65));
  { ^ oblige, car lorsque l'espace de compo est minimun, il y a }
  { un bug (pas d'evolution curseur significative!) }
end;

function KeyInPanel : boolean;
{ Action particuliere d'une touche dans un champ }
begin
  if ((inter.SelectField>=FieldPanel) and
      (inter.SelectField<=FieldPanel+NbreAtt-1)) then
  { pas de doute, on est devant un cas exceptionnelle!!! }
    if inter.ChoixField then
      { bouton enfonce alors qu'on appuie sur une touche }
      KeyInPanel:= false
    else
      { Aucun choix n'etait en cours alors qu'on est sur un champs }
      case Key of
        #32 : { ESPACE : On active/desactive le champ actuel }
              begin
                AttActif[inter.SelectField-FieldPanel]:=
                not(AttActif[inter.SelectField-FieldPanel]);
                AffAtt(PB.Panel,inter.SelectField-FieldPanel);
                KeyInPanel := true;
              end;
      else KeyInPanel:= false;
      end
    else KeyInPanel:= false;
end;

function PanelChoix : boolean;
{ choix d'un champ du panel }
begin
  if (inter.SelectField>=FieldPanel) and (inter.SelectField<=FieldPanel+NbreAtt-1) then
    { choix d'un champs attribut }
    begin
      if inter.BtnGauche then IncAttAff(inter.SelectField-FieldPanel)
      else DecAttAff(inter.SelectField-FieldPanel);
      PanelChoix := true;
    end
  else
    if (inter.SelectField>=FieldGraphik) and (inter.SelectField<=FieldGraphik+5) then
      { choix d'un pixel graphik }
      begin
        PB.Graphik := PB.Graphik xor (1 shl (inter.SelectField-FieldGraphik));
        AffGra;
        PanelChoix := true;
      end
    else 
     If inter.SelectField=131 Then
      Begin  { Extended G1 }
       SwapExtG1;
      End
     Else PanelChoix := false; { choix non determine }
end;

function MemChoix : boolean;
{ choix dans l'un des champs MEM }
begin
  if (inter.SelectField=FieldMem) then
    { choix vrai }
    begin
      if inter.BtnGauche then IncMem else DecMem;
      MemChoix := true;
    end
  else MemChoix := false;
end;

function AffVrai(var M : MemPg_Rec; Speed : boolean) : boolean;

  type Aiguillage = (NUL,ESC,PRO1,PRO2,PRO3,FILT,ISO2022,ISO6429);

  var NCL : word;
      Aig : Aiguillage;

  procedure InitTruf;
  begin
    NCL := 0;
    Aig := NUL;
  end;

  procedure Truf( c : char );
  var i,t : word;
  begin
    inc(NCL);
    case Aig of
      NUL : if c=#27 then Aig := ESC;
      ESC :
        case c of
          #$39 : Aig := PRO1;
          #$3A : Aig := PRO2;
          #$3B : Aig := PRO3;
          #53..#55 : Aig := FILT;
          #32..#47 : Aig := ISO2022;
          #91  : Aig := ISO6429;
        else Aig := NUL;
        end;
      PRO1 : Aig := NUL;
      PRO2 : Aig := PRO1;
      PRO3 : Aig := PRO2;
      FILT : AIg := NUL;
      ISO6429 : if c>=#64 then Aig := NUL; { fin de la sequence }
      ISO2022 : if c>=#48 then Aig := NUL; { idem }
    end;
    if (Aig=NUL) then
      begin
        for i := 1 to NCL do
          for t := 1 to Cfg.CZ do Mntl.Write(#0);
        NCL := 0;
      end;
  end;

{ Speed = TRUE vitesse maximun sinon 1200 bauds }
var Good : boolean;
    i   : word;
    t   : word;
    c   : char;
    l   : Word;
    Ram : RamFile;
    Abort: Boolean;
begin
  StopRAff;

  Ram.Init;

  if CompilVrai(Ram,M,FALSE) then
    begin
      Abort := FALSE;
      Good := true;
      l    := Ram.Size;
      NewTotalCodes(cM^,l);
      i    := l;
      if not(speed) and (CFG.CZ>=0) then
        if CFG.PAUSE then
         Abort := Not(WaitOutEmpty)  { afin de bien simuler avec buffer out ! }
        else InitTruf;
      while Not(Abort) And (i>0) do
        begin
          c := char(Ram.Get);
          Mntl.Write(c);
          if not(speed) and (CFG.CZ>=0) then
            if CFG.PAUSE then delay(Cfg.CZ) else Truf(c);
          dec(i);
          Abort := AbortRequest;
        end;
    end
  else Good := false;

  Ram.Done;

  AffVrai := Good;
end;


function GlobalKey : boolean;
{ CTRL PgUp ou PgDn ou CTRL F1 ou CTRL F2 (affichage rel)
   ou CTRL F3 (affichage standart)
 }
var bidon : boolean;
begin
  GlobalKey := true;
  if Funct then
    case Key of
      #118 : DecMem; { CTRL PgDn }
      #132 : IncMem; { CTRL PgUp }
      #94  : begin
             bidon := AffVrai(cM^,TRUE); { CTRL F1 (aff vrai reel) }
             ExCurY := ScreenHigh; { restimule le curseur }
             end;
      #95  : begin
             bidon := AffVrai(cM^,FALSE); { CTRL F2 (aff vrai a 4800) }
             ExCurY := ScreenHigh; { restimule le curseur }
             end;
      #96  : begin { CTRL F3   affichage standart }
              ForceGlobalRefresh;
              ReadyForRAff;
              ExCurY := ScreenHigh;
             end;
      #97  : begin { CTRL F4   reset minitel }
              ForceGlobalRefresh;
              ReadyForRAff;
              ExCurY := ScreenHigh;
             end;
      #45,#16 : Begin { Alt+X ou Alt+Q }
                 GestEndProg;
                End;

    else GlobalKey := false;
    end { case of }
  else GlobalKey := false;
end;


function EditKey: boolean;
  procedure DecalNeg(x,y : byte);
  var iX : byte;
  begin
    KeepMem(NumPage,y,1);
    for iX:=x to PXbas-1 do cM^.Ram[y,iX]:=cM^.Ram[y,iX+1];
    cM^.Ram[y,PXbas] := Vierge;
  end;

  procedure DecalPos(x,y: byte);
  var iX : byte;
  begin
    KeepMem(NumPage,y,1);
    for iX:=PXbas-1 downto x do cM^.Ram[y,iX+1] := cM^.Ram[y,iX];
    cM^.Ram[y,x]:=Vierge;
  end;

  procedure AffLigne(x,y: byte);
  var iX  : byte;
      c   : VDispRamEl;
  begin
    for iX := x to PXbas do
      begin
       c := cM^.Ram[y,iX];
       AffVdtChar(c.Car,iX,y,c.Att);
      end;
  end;

  procedure Del;
  begin
    DecalNeg(CurX,CurY);
    AffLigne(CurX,CurY);
  end;

  procedure Ins;
  begin
    DecalPos(CurX,CurY);
    AffLigne(CurX,CurY);
  end;

  procedure PropAtt;
  var car : byte;
  begin
    car:=Byte(cM^.Ram[CurY,CurX].Car);
    if car=0 then car := 32;
    GereCar(car,GetPanel Or (TakeAttRam(CurX,CurY) And (Graphik+DRCS+Delim)),
            FALSE,CurX,CurY);
  end;

  procedure PropVide;
  begin
    KeepMem(NumPage,CurY,1);
    cM^.Ram[CurY,CurX] := Vierge;
    AffVdtChar(#0,CurX,CurY,BasePanel);
    Mntl.Write(#31+char(CurY+64)+char(CurX+65));
    Mntl.Write(char(14)+char(32));
    SimpleNextPos(CurX,CurY);
  end;

  procedure InvGra;
  var Gra : byte;
  begin
    if (TakeAttRam(CurX,CurY) and Graphik)<>0 then
      begin
        Gra := InvGraphCorrector(Byte(cM^.Ram[CurY,CurX].Car)) xor 63;
        Gra := GraphCorrector(Gra+32);
        GereCar(Gra,cM^.Ram[CurY,CurX].att,(cM^.Ram[CurY,CurX].att And Delim<>0),CurX,CurY);
      end;
  end;

  procedure EchCoul;
  begin
    with cM^.Ram[CurY,CurX] do
      if Car<>#0 then
        begin
          att := (att and not(63)) or (((att and 56) shr 3) or
                 ((att and 7) shl 3));
          GereCar(Byte(Car),att, (att And Delim<>0), CurX,CurY);
        end
      else SimpleNextPos(CurX,CurY);
  end;

begin
  if Funct then
    (*
    Case Key Of
     #115 : { Ctrl <- }
            If Not(UndoMem) Then Beep;
     #116 : { Ctrl -> }
            If Not(UnUndoMem) Then Beep;
    Else *)
      if (CTRL and 4)=0 then
        begin { touche ctrl non enfonce }
          case Key of
            #83 : Del;
            #82 : Ins;
            else
              begin
                EditKey := false;
                exit;
              end;
          end;
        end
      else { touche ctrl }
        begin
          EditKey := false;
          exit;
        end
(*    End *)
  else { not funct }
    begin
      case Key of
        #8  : if CurX<>PXhaut then { backspace }
                begin
                  dec(CurX);
                  Del;
                end;
        #4  : Del; { ctrl d }
        #6  : Ins; { ctrl f }
        #16 : PropAtt; { ctrl p }
        #22 : PropVide; { ctrl v }
        #23 : PropAtt; { ctrl W }
        #14 : InvGra;  { ctrl N }
        #05 : EchCoul; { ctrl E }
      else
        begin
          EditKey := false;
          exit;
        end;
      end; { case of }
    end; { not funct }
  EditKey := true;
  GoXY(CurX,CurY);
end;


Function  SmallPanel( Titre : String;
                      Var p; SizeTab : Byte; Inv : Boolean;
                      nc : Byte; Var result : Byte ) : Boolean;
{ par rapport a la position du curseur CurX, CurY }
Var Tab : Array[0..20] Of String[9] Absolute p;
    Zn  : Zn_Rec;
    zz  : Zn_Rec;
    y   : Byte;
    m2  : Byte;
    i   : Byte;
    EndB : Boolean;
    Refresh : Boolean;
    Good    : Boolean;
Begin
 If nc>=SizeTab Then nc := SizeTab-1;

 If Inv Then nc := SizeTab-1-nc;

 y := CurY;

 m2 := (SizeTab+2) Div 2;
 If y<m2 Then y := 0
 Else
  Begin
   y := y-m2;
   If y+(SizeTab+2)>=25 Then y := 25-(SizeTab+2);
  End;

 Zn.x := CurX+21;
 Zn.y := y;
 Zn.lg := 11;
 Zn.Ht := SizeTab+2;

 PushZn(Zn);
 ClrZn(Zn,CWind);
 CCdrZn(Zn,CDRDOUBLE,CCadre);

 WrtScr(Titre,Zn.x+CentralPos(Length(Titre),Zn.lg-2),Zn.y,CCadre);

 For i := 0 To SizeTab-1 Do
  Begin
   If Inv Then y := Zn.y+(SizeTab-i)
   Else y := Zn.y+i+1;
   WrtScr(Tab[i],Zn.x+1,y,CWind);
  End;


 EndB := FALSE;
 Refresh := TRUE;

 zz.Lg := 0;

 While Not(EndB) Do
  Begin
   If Refresh Then
    Begin
     If zz.Lg<>0 Then AspZn(zz,CWind);

     zz.x  := Zn.x+1;
     zz.y  := Zn.y+1+nc;
     zz.Lg := 9;
     zz.Ht := 1;
     AspZn(zz,SurEvidenceField);

     Refresh := FALSE;
    End;

   ViewKey;
   If Key<>#0 Then
    Begin
     If Not(Funct) Then
      Begin
       Case Key Of
        #27 : Begin
               EndB := TRUE;
               Good := FALSE;
              End;
        #13 : Begin
               EndB := TRUE;
               Good := TRUE;
              End;
       Else TheBeep;
       End;
      End
     Else
      Begin
       Case Key Of
        #72,#73 : Begin { Up }
               If nc=0 Then nc := SizeTab-1 Else Dec(nc);
               Refresh := TRUE;
              End;
        #80,#81 : Begin { Down }
               Inc(nc);
               If nc>=SizeTab Then nc := 0;
               Refresh := TRUE;
              End;
        #71 : Begin { home }
               nc := 0;
               Refresh := TRUE;
              End;
        #79 : Begin { End }
               nc := SizeTab-1;
               Refresh := TRUE;
              End;
       Else TheBeep;
       End;
      End;
    End;
  End;

 PopZn;

 If Good Then
  If Inv Then Result := SizeTab-1-nc
  Else result := nc;
 SmallPanel := Good;
End;



Function EditKeyNeutre: boolean;

 procedure TakeGra;
 begin
   if (TakeAttRam(CurX,CurY) and Graphik)<>0 then
     begin
       PB.Graphik := InvGraphCorrector(Byte(cM^.Ram[CurY,CurX].Car));
       AffGra;
     end;
 end;

 procedure TakeAtt;
 type PtrRec = record
         Ofs,Seg : word;
       end;
 begin
   PB.Panel :=TakeAttRam(CurX,CurY);
   PB.Panel := GetPanel;
   AffAllAtt;
 {  GotoXY(1,1);
   write('Xc=',Xcur,' Yc=',Ycur,' Pn=',PB.Panel,' Np=',NumPage,
         ' cM.Ofs=',PtrRec(cM).Ofs,' cM.Seg=',PtrRec(cM).Seg,'.');
 }
 end;

Var result : Byte;
Begin
 If Funct Then
  Begin
   Case Key Of
    #20 : { Alt T }
          Begin
           If SmallPanel('Trait',TxtCoul,8,TRUE,ReadAtt(PB.Panel,0),result) Then
            Begin
             WrtAtt(PB.Panel,0,result);
             AffAtt(PB.Panel,0);
            End;
          End;
    #33 : { Alt F }
          Begin
           If SmallPanel('Fond',TxtCoul,8,TRUE,ReadAtt(PB.Panel,1),result) Then
            Begin
             WrtAtt(PB.Panel,1,result);
             AffAtt(PB.Panel,1);
            End;
          End;
    #44 : { Alt Z }
          Begin
           If SmallPanel('Taille',TxtTail,4,FALSE,ReadAtt(PB.Panel,2),result) Then
            Begin
             WrtAtt(PB.Panel,2,result);
             AffAtt(PB.Panel,2);
            End;
          End;
    #23 : { Alt I }
          Begin
           If SmallPanel('Invers',TxtBin,2,TRUE,ReadAtt(PB.Panel,3),result) Then
            Begin
             WrtAtt(PB.Panel,3,result);
             AffAtt(PB.Panel,3);
            End;
          End;
    #31 : { Alt S }
          Begin
           If SmallPanel('Stable',TxtBin,2,TRUE,ReadAtt(PB.Panel,4),result) Then
            Begin
             WrtAtt(PB.Panel,4,result);
             AffAtt(PB.Panel,4);
            End;
          End;
    #34 : { Alt G }
          Begin
           If SmallPanel('Soulign',TxtBin,2,TRUE,ReadAtt(PB.Panel,5),result) Then
            Begin
             WrtAtt(PB.Panel,5,result);
             AffAtt(PB.Panel,5);
            End;
          End;
    #50 : { Alt M }
          Begin
           If SmallPanel('Masqu',TxtBin,2,TRUE,ReadAtt(PB.Panel,6),result) Then
            Begin
             WrtAtt(PB.Panel,6,result);
             AffAtt(PB.Panel,6);
            End;
          End;
   Else
    Begin
     EditKeyNeutre := FALSE;
     Exit;
    End;
   End;
  End
 Else { not funct }
  Begin
   Case Key Of
    #1,#20 : TakeAtt; { Ctrl A / Ctrl T }
    #19    : TakeGra; { ctrl s }
   Else
    Begin
     EditKeyNeutre := FALSE;
     Exit;
    End;
   End; { case of }
  End; { not funct }
 EditKeyNeutre := TRUE;
 GoXY(CurX,CurY);
End;

Function CtrlK : Boolean;
Begin
 If Not(Funct) And (Key=#11) Then  { Ctrl K }
  Begin
   LnRAff(CurY);
   CtrlK := TRUE;
   GoXY(CurX,CurY);
  End
 Else CtrlK := FALSE;
End;
