{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

{$M $4000,0,$35000 }

program CONCEPT;
uses Dos,Crt,VdtDisp,Colors,VdtTools,Video60,XSer,InterCon,DirCon,
     Stringer,EmulM2,RamDisk2,ForSave,ConTools,Error;

{$I VAR.PAS }
{$I MEM.PAS }
{$I CMPTOOLS.PAS }
{$I MENUCON.PAS }

function ButtonPress : boolean;
var info : boolean;
begin
  ButtonPress:= true;
  if ButtonL then
    begin
      case ParamL of
        1 : { on considere l'espace compo comme 960 champs }
            info:=CompoField;
      else
        begin { aucune selection est en cours! }
          CadrageChoix;
          ButtonPress := TRUE;
          Exit;

          ButtonPress:=false;
          exit;
        end;
      end; { case of }
      case SelectL of
        17 : { Graphique }
             if info then
               begin
                 PutCar(CalcGraphCode(PB.Graphik,DRCSActif),GetPanelCar Or Graphik,CurX,CurY);
                 ReportRAff( 18 );
                 ExCurX := ScreenLong; { simulation de variation }
               end
             else TheBeep;
      else
        begin
{$IFDEF DEBUG }
          GotoXY(21,1);
          write('SelectL:',SelectL,' no solution!');
{$ENDIF }
        end;
      end;
    end
  else
    if ButtonR then
      begin
        case ParamR of
         1 : info := CompoField;
        else
          begin { aucune selection en cours }
            ButtonPress:=false;
            exit;
          end;
        end; { case of }
        case SelectR of
          1 : { emission de la ligne vers minitel }
               if info then LnRAff(CurY)
               else TheBeep;
        else
          begin
{$IFDEF DEBUG }
            GotoXY(21,1);
            write('SelectL:',SelectR,' no solution!');
{$ENDIF }
          end;
        end; { case of }
      end
    else ButtonPress := false;
end;

function PenGraphikChoix : boolean;
begin
  if inter.SelectField=FieldPenGraphik then
    begin
      if SelectL=FieldPenGraphik then
        begin
          SelectL:=0;
          ParamL:=0;
          Fld[inter.FieldEcran].select := false;
        end
      else
        begin
          SelectL:=17;
          ParamL:=1;
          Fld[inter.FieldEcran].select := true;
        end;
      PenGraphikChoix := true;
    end
  else
    PenGraphikChoix := false;
end;


{************* CHARGE VIDEOTEX **************}

function LoadSingleVideotex( Var name : string) : boolean;
const Mx_lg = 1024;

type intermed_map = array[1..Mx_lg] of byte;
var io : word;
    Good : boolean;
    intermed : ^intermed_map;
    fichier : File;
    result : word;
    index : word;
    Em    : EmulRec;
    r     : Word;
begin
  Good := False;
  if Name<>'' then
    begin
      assign(fichier,Name);
      reset(fichier,1);
      io := ioresult;
      if GestFileError(io) then
        begin
          KeepMem(NumPage,0,ScreenHigh);  { sauve !!! }

          Good := true;

          InitEmul(Em,@cM^.Ram,@cM^.DRCS);
          DelimRam(Em.Ram);

          Em.Cfg := Cfg.Emul;

          Em.Stat.MdIns  := FALSE;
          Em.Stat.MdPage := TRUE;

          new(intermed);
          repeat
            BlockRead(fichier,intermed^,Mx_lg,result);
            io := ioresult;
            if io=0 then
              for index := 1 to result do r := Emul(Em,Char(intermed^[index]));
          until (io<>0) or (result<Mx_lg) Or AbortRequest;
          dispose(intermed);

          ClearDelim(Em.Ram,FALSE);

          Good := GestFileError(io);
          close(fichier);
          io := ioresult;
          if not(GestFileError(io)) then Good := false;
        end;
    end
  else Good := GestFileError(190);

  LoadSingleVideotex := Good;
end;


function LoadSingleMem( Var name:string) : boolean;
var io : word;
    f  : File;
begin
  if name<>'' then
    begin
      assign(f,name);
      reset(f,1);
      io := ioresult;
      if GestFileError(io) then
        begin
          KeepMem(NumPage,0,ScreenHigh);
          BackRefresh;

          if GestLoad(f,cM^) then LoadSingleMem := CloseFile(f)
          else
            begin
              LoadSingleMem := CloseFile(f); {  bidon  }
              LoadSingleMem := false;
            end;
        end
      else
        LoadSingleMem := false
    end
  else
    LoadSingleMem := GestFileError(190)
end;


{*************** Menu Charge et sauve ********************}

procedure ChargeMenu;
const Xdti = 26; Ydti = 18+2; Xvdt = 5; Yvdt = 18+2;
var Zn : Zn_Rec;
begin
  Zn.x := ZnDir.x+xdti;
  Zn.y := ZnDir.y+ydti;
  Zn.lg := 15;
  Zn.ht := 3;
  CCdrZn(Zn,CDRNORM,FWind+TMiNet);
  WrtScr('CHARGE SOURCE',Zn.X+1,Zn.y+1,FWind+TMiNet);
  WrtScr('(DTI)',Zn.X+5,Zn.Y+2,FWind+TMiNet);
  Zn.x := ZnDir.x+xvdt;
  Zn.y := ZnDir.y+yvdt;
  Zn.lg := 17;
  Zn.ht := 3;
  CCdrZn(Zn,CDRNORM,FWind+TMiNet);
  WrtScr('CHARGE VIDEOTEX',Zn.x+1,Zn.y+1,FWind+TMiNet);
{  WrtScr(CentreString('('+ExtVideotex+')',5,196),Zn.x+6,Zn.y+2,FWind+TMiNet); }
  WrtScr(' ABANDON ',Zndir.x+2,Zndir.y+23,CChoix);
end;

procedure Chargement;
var index : byte;
    EndBoucle : boolean;
    PY : byte;
    name : string[12];
    svFileName : string[12];

 Procedure Abandon;
 Begin
  cM^.FileName := svFileName; { restore le nom car abandon! }
  EndBoucle := true;
 End;

 Procedure LoadDTI;
 Begin
  if IgnoreChange(cM^) then
    begin
    OpenWindDiskOp;
    name := ForceExt(cM^.FileName,'DTI');
    WriteDiskOp('CHARGEMENT DU FICHIER SOURCE '''+name+'''',1);
    if LoadSingleMem(name) then
      begin
        ClrMemChange(cM^);
        EndBoucle := true;
        ResetAffCompo := TRUE;
      end;
    PopZn;
    end;
 End;

 Procedure LoadVDT;
 Begin
  OpenWindDiskOp;
  name := ForceNoExt(cM^.FileName,Cfg.Ext);
  WriteDiskOp('CHARGEMENT DU FICHIER VIDEOTEX '''+name+'''',1);
  if LoadSingleVideotex(name) then
    begin
      { if svFileName<>'' then M.FileName := svFileName; }
      EndBoucle := true;
      ResetAffCompo := TRUE;
    end;
  PopZn;
 End;

Var zter : Boolean;
begin
  if DiskWind(24) then
    begin
      ChargeMenu;
      EmpileFld;
      for index := 44 to 54+HautWindDir do ChsFld(index);
      ChsFld(139);
      ChsFld(78); ChsFld(79); ChsFld(80);
      ResetDirWind(cM^);
      PY := PYhaut;
      PYhaut := ScreenHigh;
      svFileName := cM^.FileName;
      EndBoucle := false;
      repeat
        zter := Interaction;

        If Key<>#0 Then
         If Not(Funct) Then
          Begin
           Case UpCase(Key) Of
            #27,'A' : Abandon;
            #13,'D','S' : LoadDTI;
            'V' : LoadVDT;
           Else TheBeep;
           End;
          End
         Else TheBeep
        Else
         if zter Then
          Begin
           if not(DirWindChoix(cM^)) then
             case inter.SelectField of
               80 : Abandon;
               79 : LoadDTI;
               78 : LoadVDT;
             else NoFieldLand;
             end; { case of }
          End;
      until EndBoucle;
      PYhaut := PY;
      DepileFld;
    end;
  DisposeDir; { libere la memoire alloue pour le dir }
  PopZn;
end;

procedure SauveMenu;
var Zn : Zn_Rec;
begin
  Zn.x := Zndir.x+14;
  Zn.y := Zndir.y+18+2;
  Zn.lg := 20;
  Zn.ht := 4;
  CCdrZn(Zn,CDRNORM,FWind+TMiNet);
  WrtScr('SAUVE',Zn.x+7,Zn.y+1,FWind+TMiNet);
  WrtScr('SOURCE et VIDEOTEX',Zn.x+1,Zn.y+2,FWind+TMiNet);
  WrtScr('(DTI)',Zn.x+2,Zn.y+3,FWind+TMiNet);
  WrtScr(CentreString('('+Cfg.Ext+')',5,196),Zn.x+13,Zn.y+3,FWind+TMiNet);
  WrtScr(' ABANDON ',Zndir.x+2,Zndir.y+23,CChoix);
end;

procedure Sauvegarde( var M : MemPg_Rec );
var index : byte;
    EndBoucle : boolean;
    PY : byte;
    name : string[12];
{    svFileName : string[12]; }

 Procedure Abandon;
 Begin
{ M.FileName := svFileName; }
  EndBoucle := true;
 End;

 Procedure Sauvegarde;
 Begin
  OpenWindDiskOp;
  name := ForceExt(M.FileName,'DTI');
  WriteDiskOp('SAUVEGARDE DU FICHIER SOURCE '''+name+'''',1);

  CreatBackUp(name);

  EndBoucle := SaveSingleMem(M,name);
  if EndBoucle then
    begin
      ClrMemChange(M);
      PopZn;
      OpenWindDiskOp;
      name := ForceExt(M.FileName,Cfg.Ext);
      WriteDiskOp('SAUVEGARDE DU FICHIER VIDEOTEX',1);
      WriteDiskOp(''''+CFG.ChSave+name+'''',2);
      EndBoucle := SaveSingleVideotex(M,CFG.ChSave,name);
    end;
  PopZn;
 End;

Var zter : Boolean;
begin
  if DiskWind(24) then
    begin
      SauveMenu;
      EmpileFld;
      for index := 44 to 54+HautWindDir do ChsFld(index);
      ChsFld(139);
      ChsFld(81);
      ChsFld(82);
      ResetDirWind(M);
      PY := PYhaut;
      PYhaut := ScreenHigh;
{      svFileName := M.FileName; }
      EndBoucle := false;
      repeat
        zter := Interaction;

        If Key<>#0 Then
         If Not(Funct) Then
          Begin
           Case UpCase(Key) Of
            #27, 'A' : Abandon;
            'S'      : Sauvegarde;
           Else TheBeep;
           End;
          End
         Else TheBeep
        Else
         if zter Then
          Begin
           if not(DirWindChoix(M)) then
             case inter.SelectField of
               82 : Abandon;
               81 : Sauvegarde;
             else NoFieldLand;
             end; { case of }
          End;
      until EndBoucle;
      PYhaut := PY;
      DepileFld;
    end;
  DisposeDir; { libere la memoire alloue pour le dir }
  PopZn;
end;

function RepertoiresChoix : boolean;
  function EnterPath(var Path : string; Y : byte) : string;
  var Zn : Zn_Rec;
      s  : string;
      pos: word;
  begin
    Zn.x :=7;
    Zn.y :=y;
    Zn.lg := 66;
    Zn.ht := 3;
    PushZn(Zn);
    ClrZn(Zn,TNet);
    CCdrZn(Zn,CDRNORM,CCadre);
    s := Path;
    pos := 256;
    if InputString(s,pos,255,Zn.lg-2,Zn.x+1,Zn.y+1) then
      begin
        KillData(s,32);
        UpCaseStr(s);
        Path := s;
      end;
    EnterPath := Path;
    PopZn;
  end;
const Tab : array[1..2] of StrChoix = ('Chainage','Sauvegarde');
var EndBoucle : boolean;
    GoodOp : boolean;

 Procedure Abandon;
 Begin
  EndBoucle := true;
  GoodOp := false;
 End;

 Procedure Chainage;
 Begin
  CFG.ChChain := EnterPath(CFG.ChChain,2);
  EndBoucle := true;
  GoodOp := false;
 End;

 Procedure Sauvegarde;
 Begin
  CFG.ChSave := EnterPath(CFG.ChSave,4);
  AjouteAntiSlash(CFG.ChSave,sizeof(CFG.ChSave)-1);
  EndBoucle := true;
  GoodOp := false;
 End;

begin
  NewMenu('Rp. Videotex',Tab,2);
  EndBoucle := false;
  GoodOp := false;
  repeat
    InterSay := interaction;
    If Key<>#0 Then
     If Not(Funct) Then
      Begin
       Case UpCase(Key) Of
        #27 : Abandon;
        'C' : Chainage;
        'S' : Sauvegarde;
       Else TheBeep;
       End;
      End
     Else TheBeep
    Else
     if InterSay then { curseur hors compo }
      begin
            case inter.SelectField of
              19 : Abandon;
              21 : Chainage;
              23 : Sauvegarde;
            else NoFieldLand;
            end; { case of }
      end;

  until EndBoucle;
  EndNewMenu;
  RepertoiresChoix := GoodOp;
end;

procedure DiskChoix;
const Tab : array[1..3] of StrChoix = ('Chargement','Sauvegarde','Rp. Videotex');
var EndBoucle : boolean;

 Procedure Abandon;
 Begin
  EndBoucle := true;
 End;

 Procedure Charge;
 Begin
   Chargement;
   EndBoucle := true;
 end;

 Procedure Sauve;
 begin
   Sauvegarde(cM^);
   AffUnderDisk(cM^);
   EndBoucle := true;
 end;

 Procedure Rep;
 begin
  EndBoucle := RepertoiresChoix;
 End;

begin
  NewMenu('Disque',Tab,3);
  ChsFldStd;
  EndBoucle := false;
  repeat
    InterSay := interaction;
    If Key<>#0 Then
     If Not(Funct) Then
      Begin
       Case UpCase(Key) Of
        #27 : Abandon;
        'C' : Charge;
        'S' : Sauve;
        'R' : Rep;
       Else TheBeep;
       End;
      End
     Else TheBeep
    Else
     if InterSay then { curseur hors compo }
      begin
          if not(StdChoix) then
          begin
            case inter.SelectField of
              19 : Abandon;
              21 : Charge;
              23 : Sauve;
              25 : Rep;
            else NoFieldLand;
            end; { case of }
          end
      end;

  until EndBoucle;
  EndNewMenu;
end;

function ImageImprimante( var M : MemPg_Rec ): boolean;
  function PrintReady : boolean;
  var reg : registers;
      bidon : byte;
  begin
    reg.ah := $02;
    reg.dx := CFG.NumPrt;
    intr($17,reg);
    if (reg.ah and ($21+144))<>144 then
      begin
      bidon := GestWindError(2,130,E_OK);
      PrintReady := false;
      end
    else PrintReady := true;
  end;
  function Print(data : byte) : boolean;
  var reg : registers;
      bidon : byte;
  begin
    reg.dx := CFG.NumPrt;
    reg.ah := 0;
    reg.al := data;
    Intr($17,reg);
    if (reg.ah and ($21+16))<>16 then
      begin
      bidon := GestWindError(2,131,E_OK);
      Print := false;
      end
    else Print := true;
  end;
var ligne,colonne : byte;
    code : VDispRamEl;
begin
  ImageImprimante := false;
  if WindError('','Prt pour l''impression ?','',E_OUI+E_NON)=E_OK then
    begin
    if PrintReady then
      begin
      { envoi VShow^ vers l'imprimante }
      { seul les codes <32 connaissent une transformation! }
      for ligne := 1 to ScreenHigh-1 do
        begin
        for colonne := 0 to ScreenLong-1 do
          begin
          code := M.Ram[ligne,colonne];
          if code.Car=#0 then code.car:=char(_RIEN)
          else
            if (code.att and Graphik)<>0 then code.Car := Char(_CarGraphik)
            else
              if code.Car<#32 then
                begin
                  case code.Car of
                    #21 : code.Car := #232;
                    #24 : code.Car := #194;
                    #25 : code.Car := #193;
                    #26 : code.Car := #180;
                    #27 : code.Car := #195;
                  else code.Car := #32;
                  end;
                end
              else
                if code.Car=#127 then code.Car := #219;
          if not(print(Byte(code.Car))) Or AbortRequest then exit;
          end;
        if not(print(13)) or not(print(10)) then exit;
        end;
      ImageImprimante := true;
      end;
    end;
end;



Procedure EmulToScreen( Ram : PVDispRam; x, y, lg, ht : Byte ); Far;
Var iX, iY : Byte;
    c : Char;
    a : Word;
Begin
 If Ram<>NIL Then
  Begin
   For iY := y To y+Ht-1 Do
    For iX := x To x+Lg-1 Do
     Begin
      (*
      If iX>=ScreenLong Then
       Begin
        iX := iX;
        Exit;
       End;
      *)
      c := Ram^[iY,iX].Car;
      a := Ram^[iY,iX].Att;
      If (iY=0) And (iX>=36) And (iX<=38) Then
       Begin
        If c=#0 Then a := BasePanel;
        If (iX=36) Or (iX=37) Then
         Begin
          c := ' ';
         End
        Else
         Begin
          c := 'C';
          a := a Or Inverse;
         End;
        a := (a And Not(Graphik+DRCS)) Or 7;
       End;
      _AffVdtChar(c,iX,iY,a);
     End;
  End;
End;


Procedure EmulToScreenScroll( Ram : PVDispRam; y : Byte; Down : Boolean ); Far;
Var Zn  : Zn_Rec;
Begin
 If Down Then
  Begin
   Zn.X  := 20;
   Zn.Y  := Y;
   Zn.Lg := ScreenLong;
   Zn.Ht := ScreenHigh-Y;
   ZnDn(Zn,1,0);
   EmulToScreen(Ram,0,y,ScreenLong,1);
  End
 Else
  Begin
   Zn.X  := 20;
   Zn.Y  := Y;
   Zn.Lg := ScreenLong;
   Zn.Ht := ScreenHigh-Y;
   ZnUp(Zn,1,0);
   EmulToScreen(Ram,0,ScreenHigh-1,ScreenLong,1);
  End;
End;


procedure SaisieMinitel;
Var Em : EmulRec;

  procedure AffEmulDRCS( d : PVDispRamDRCS );
  var buf : string;
  begin
    if d=NIL then buf := '1B' else buf := '2';
    WrtScr(CentreString('Minitel '+buf,18,32),61,5,CDisp);
  end;

  Procedure AffRollOff;
  Begin
   FieldOff;
   WrtScr(CentreString('Mode PAGE',18,32),61,7,CDisp);
   Cfg.EmulMdPage := TRUE;
  End;

  Procedure AffRollOn;
  Begin
   FieldOff;
   WrtScr(CentreString('Mode ROULEAU',18,32),61,7,CDisp);
   Cfg.EmulMdPage := FALSE;
  End;

  procedure AffEmulModePage;
  begin
    if Em.Stat.MdPage<>Cfg.EmulMdPage then
     If Em.Stat.MdPage Then AffRollOff Else AffRollOn;
  end;

const Tab : array[1..5] of StrChoix =
        ('','','Quitter et garder','Sauvegarder','Imprimer');

var EndBoucle : boolean;
    PY : byte;
    IntReturn : boolean;
    index : byte;
    code : VdtString;
    K : PMemPg_Rec;
    bidon : boolean;
    c  : Char;
    r  : Word;
    Auto : Boolean;
    d  : PVDispRamDRCS;
    SaveProc : Pointer;
    SaveUp   : Pointer;

 Procedure Abandon;
 Begin
  ResetAffCompo := true;
  EndBoucle := true;
 End;

begin
  MinInitEmulation;

  new(K);

  InitMemPg(K^);

  K^.Ram  := cM^.Ram;  { transmet }
  K^.DRCS := cM^.DRCS;
  AffUnderDisk(K^);

  If Cfg.EmulDRCS Then d := @K^.DRCS Else d := NIL;

  InitEmul(Em,@K^.Ram,d);

  SaveProc := RamProc.Ptr;
  RamProc.Proc := EmulToScreen;

  DelimRam(Em.Ram);

  SaveUp := ScrollProc.Ptr;
  ScrollProc.Proc := EmulToScreenScroll;

  EmulToScreen(Em.Ram,0,0,ScreenLong,ScreenHigh);  { Raffraichir l'ecran }

  Em.Cfg  := Cfg.Emul;
  (*
  Em.Cfg.ToScreen := TRUE;   { normal non ? }
  *)

  Em.Stat.MdIns  := FALSE;

  Em.Stat.MdPage := Cfg.EmulMdPage;
  Cfg.EmulMdPage := Not(Cfg.EmulMdPage);

  Auto := Cfg.EmulAuto;

  NewMenu('Emulation',Tab,5);
  AffEmulDRCS( d );
  AffEmulModePage;

(*  ChsFld(19); ChsFld(21); ChsFld(23); ChsFld(25); *)

  InstallFldEga;

  PY := PYhaut;
  PYhaut := ScreenHigh;
  EndBoucle := false;
  inter.ConstantOut := true;
  repeat
    IntReturn := Interaction;
    if inter.IntNormal then
     begin
      if IntReturn and (Key=#0) then
        begin
          case inter.SelectField of
            19 : Abandon;
            21 : Begin
                  Cfg.EmulDRCS := Not(Cfg.EmulDRCS);
                  If Cfg.EmulDRCS Then d := @K^.DRCS Else d := NIL;
                  Em.DRCS := d;
                  AffEmulDRCS( d );
                 End;
            23 : begin
                   Em.Stat.MdPage := not(Em.Stat.MdPage);
                   AffEmulModePage;
                 end;
            25 : begin { ok }
                   ClearDelim(Em.Ram,FALSE);

                   KeepMem(NumPage,0,ScreenHigh);
                   cM^.Ram := K^.Ram;
                   cM^.DRCS := K^.DRCS;
                   if K^.FileName<>'' then cM^.FileName := K^.FileName;
                   ResetAffCompo := true;
                   EndBoucle := true;
                 end;
            27 : begin { sauvegarde }
                   RamProc.Ptr := SaveProc;
                   ScrollProc.Ptr := SaveUp;

                   ClearDelim(Em.Ram,FALSE);
                   Sauvegarde(K^);
                   AffUnderDisk(K^);
                   DelimRam(Em.Ram);

                   RamProc.Proc := EmulToScreen;
                   ScrollProc.Proc := EmulToScreenScroll;
                 end;
            29 : begin
                   bidon := ImageImprimante(K^);
                 end;
          Else EgaChoix(K^.Ram,K^.DRCS,TRUE,FALSE);
          end;
        end
      else
        if Key<>#0 then
          begin
          if PCKeyData(FALSE) then
            begin
              TradDataMntl(KeyCompo,code);
              Mntl.Write(code);
            end
          else
            if Funct then
              begin
                case Key of
                  #71 : Mntl.Write(#19#70); { Home Sommaire }
                  #73 : Mntl.Write(#19#66); { PgUp Retour }
                  #81 : Mntl.Write(#19#72); { PgDn Suite }
                  #79 : Mntl.Write(#19#67); { End Repetition }
                  #82 : Mntl.Write(#19#68); { Ins Guide }
                  #83 : Mntl.Write(#19#69); { Del Annulation }
                  #94 : Mntl.Write(#19#73); { CTRL+F1 Dconnexion }
                else TheBeep;
                end;
              end
            else
              case Key of
                #27 : Abandon;
                #13 : Mntl.Write(#19#65); { Enter Envoi }
                #8  : Mntl.Write(#19#71); { Correction }
              else
                if Key<#32 then Mntl.Write(Key)
                else TheBeep;
              end;
          end;
     end
    else
      if Mntl.ReceiveChar(c) then
       Begin
        r := Emul(Em,c);
        If Auto And (r=EMOP_CHGSTATUSFONC) Then Mntl.Write(#$1B#$39#$72);
        AffEmulModePage;
       End;
  until EndBoucle;
  MenuHaut;
  PYhaut := PY;
  EndNewMenu;
  dispose(K);

  MinInitAffichage;


  ScrollProc.Ptr := SaveUp;
  RamProc.Ptr := SaveProc;
end;

procedure ExtraChoix;
const Tab : array[1..4] of StrChoix = ('Emulation','Accs DOS',
                'Tltransmission','Imprimer' );
var EndBoucle : boolean;

 Procedure Emule;
 Begin
  StopRAff;

  SaisieMinitel;
  AffUnderDisk(cM^);

  DelayRAff;

  EndBoucle := true;
 End;

 Procedure GoDOS;
 Begin
  CommandesDos;
  EndBoucle := true;
 End;

 Procedure Tele;
 Begin
  if WindError('','Prt pour la transmission ?','',
       E_OUI+E_NON)=E_OK then
    begin

    ImageTelephone(cM^);

    GlobalRefresh;

    EndBoucle := true;
    end;
 End;

 Procedure Impr;
 Begin
  EndBoucle := ImageImprimante(cM^);
 End;

 Procedure Vide;
 Begin
  if IgnoreChange(cM^) then
    begin
      KeepMem(NumPage,0,ScreenHigh);
      BackRefresh;
      InitMemPg(cM^);
      ResetAffCompo := TRUE;
      EndBoucle := true;
    end;
 End;

Var zter : Boolean;
begin
  NewMenu('Extras',Tab,4);
  MakeTrait(20,2,2);
  WrtScr(CentreString('Vider la mmoire',18,32),61,21,CDisp);
  WrtScr(CentreString('Quitter',18,32),61,23,CDisp);
  ChsFld(37);
  ChsFld(39);
  ChsFldStd;
  EndBoucle := false;
  repeat
    zter := Interaction;
    If Key<>#0 Then
      If Not(Funct) Then
       Begin
        Case UpCase(Key) Of
         #27 : EndBoucle := TRUE;
         'E' : Emule;
         'D' : GoDOS;
         'T' : Tele;
         'I' : Impr;
         'V' : Vide;
         'Q' : Begin
                GestEndProg;
                EndBoucle := TRUE;
               End;
        Else TheBeep;
        End;
       End
      Else TheBeep
    Else
     If zter then { curseur hors compo }
      Begin
       if not(StdChoix) then
        begin
          case inter.SelectField of
            19 : EndBoucle := true;
            21 : Emule;
            23 : GoDOS;
            25 : Tele;
            27 : Impr;
            37 : Vide;
            39 : begin
                   GestEndProg;
                   EndBoucle := true; { si on en sort }
                 end;
           else NoFieldLand;
           end; { case of }
        end;
      End;
  until EndBoucle;
  EndNewMenu;
end;



Procedure AnnonceVitesse;
Var s : String;
    v : Byte;
Begin

 If (inter.BtnGauche) Or (Cfg.CZ<0) Then v := Cfg.Speed
 Else v := Cfg.Reel;

 Str(115200 Div TabSpeed[v].BD,s);
 s := '( '+s+' BAUDS )';

 WrtScr(CentreString(s,18,32),61,4+2,SurEvidenceField);
End;


function MenuGeneralChoix : boolean;
begin
  MenuGeneralChoix := true;
  case inter.SelectField of
    18 : begin
          AnnonceVitesse;
          If AffVrai(cM^,inter.BtnGauche) Then ;
         end;
    22+2 : ParamChoix(cM^);
    25+2 : CadrageChoix;
    28+2 : DiskChoix; { disque }
    30+2 : ExtraChoix;
(*    37 : GestEndProg; { sortir } *)
   136 : begin { Annule }
          If Not(UndoMem) Then Beep;
         end;
   137 : Begin { Restaure }
          If Not(UnUndoMem) Then Beep;
         End;
   127 : Begin
          Cfg.GlobalRaff := Not(Cfg.GlobalRaff);
          RAffSmallMenu;
         End;
   128 : Begin
          cM^.IntroRAff := Not(cM^.IntroRAff);
          RAffSmallMenu;
          BackRefresh;
          GlobalRefresh;
         End;
(*
   129 : Begin
          EditDRCS;
         End;
*)
   140 : Begin  { Page }
          ForceGlobalRefresh;
         End;
   141 : Begin  { Fond }
          AfficheBack;
         End;
   142 : Begin  { Vide }
          StopRAff;
          ClrDelayRAff;
          MinReset;
          ResetRAff;
         End;
  else MenuGeneralChoix := false;
  end;
end;

procedure IntroCompo;
var index : word;
begin
  WrtScr('͵',0,8,CSep);

  WrtScr('Ĵ',PanelGraX-1,PanelGraY-1,CSep);
  for index := PanelGraY to PanelGraY+2+2 do WrtScr('',PanelGraX-1,index,CSep);
  WrtScr('',PanelGraX,PanelGraY+3,CSep);
  WrtScr('Ĵ',PanelGraX-1,PanelGraY+5,CSep);

  WrtScr('',1,16,CSep);
  WrtScr('   D.R.C.S   ',1,17,CDisp);
  WrtScr('',1,18,CSep);
  WrtScr('Souris Graph.',1,19,CDisp);
  WrtScr('',1,20,CSep);

  ChsFld(FieldPenGraphik); { field graphique }

  ChsFldStd;
  InstallFldEga;

  ShowCarRien;

  WrtScr('Affiche Fond Vide+',61,3,CDisp);
  WrtDt(Byte(''),61+7,3,CSep);
  WrtDt(Byte(''),61+12,3,CSep);
  WrtScr('',61,4,CSep);
  WrtScr(CentreString('Affichage rel',18,32),61,3+2,CDisp);
  WrtScr(FillString(18,32),61,4+2,CMiNet);
  WrtScr('',61,7,CSep);
  WrtScr(CentreString('Paramtrage',18,32),61,6+2,CDisp);

  WrtScr('Ĵ',60,9,CSep);
  WrtScr(CentreString('Zonage',18,32),61,9+2,CDisp);
  MakeTrait(11+2,3,2);
  WrtScr(CentreString('Disque',18,32),61,12+2,CDisp);
  WrtScr(CentreString('Extras',18,32),61,14+2,CDisp);

  WrtScr('Ĵ',60,22,CSep);
  WrtScr(' Annule ',61,23,CDisp);
  WrtScr(' Restaure',70,23,CDisp);
  WrtScr('',69,23,CSep);

  ChsFld(18); ChsFld(22+2); ChsFld(25+2); ChsFld(28+2); ChsFld(30+2);
  ChsFld(136); ChsFld(137);

  ChsFld(127); ChsFld(128); ChsFld(129); ChsFld(130);

  ChsFld(140); ChsFld(141); ChsFld(142);

  AffEgaVAttr;
end;

procedure Compose;
var o : boolean;
    NewStart : Boolean;
begin
  NewStart := TRUE;

  InitFld;
  IntroCompo;
  SelectR := 1;
  ParamR  := 1;
  SelectL := 0;
  ParamL  := 0;

  SaveProc := InterProc;
  InterProc := InterRefresh;

  If MinConnected Then
   If Not(MinOnLine) Then { refaire un test ... }
    Begin
     MinReset;
    End;

repeat
  RAffSmallMenu;
  AffAllAtt;
  AffGra;
  AffUnderDisk(cM^);
  AffNbCodes;
  AffShow;
  ResetAffCompo := false;

  If MinConnected And NewStart Then
   Begin
    StopRAff;

    SaisieMinitel;
    AffUnderDisk(cM^);

    DelayRAff;
   End;

  NewStart := FALSE;
  repeat
    ReadyForRAff;

    InterSay := Interaction;
    if InterSay then { curseur hors compo }
      begin
        if key=#0 then
          begin { la cause est un choix FAIT }
            if not(StdChoix) then
             if not(PenGraphikChoix) then
              if Not(MenuGeneralChoix) then
               If Not(EgaChoix(cM^.Ram,cM^.DRCS,FALSE,TRUE)) Then NoFieldLand;
          end
        else
          begin { la cause une l'action sur une touche }
            { les action sur un champ d'abord }
            if not(PanelCMD) then
            { les action hors champ ensuite }
              if not(KeyInPanel) then
              if not(GlobalKey) then NoFieldLand;
          end;
        AffChg(cM^);
        AffNbCodes;
        ResetCur := TRUE;

        ExCurY := ScreenHigh;
      end
    { curseur dans la compo }
    else
     Begin
      (*
      GotoXY(1,1);
      System.Write('[',MemAvail:10,']');
      *)
      if ButtonPress then
       Begin
        AffChg(cM^);
        AffNbCodes;

        ExCurY := ScreenHigh;
       End
      Else
       if Key<>#0 then
        Begin
         if CurseurMove(true) then ReportRAff( 18 )
         Else
         if PCKeyData(DRCSActif) then
           begin
             GereCar(byte(KeyCompo),GetPanelCar,(CTRL And 4<>0),CurX,CurY);
             ReportRAff( 18 );
           end
         else
           if (Key=#7) and not(FUNCT) then
             begin
               GereCar(CalcGraphCode(PB.Graphik,DRCSActif),GetPanelCar Or Graphik,FALSE,CurX,CurY);
               ReportRAff( 18 );
             end
           else
             if EditKey Or EditKeyNeutre then ReportRAff( 18 )
             Else
              If Not(CtrlK) Then
               if not(PanelCMD) then
                 if not(GlobalKey) then NoManLand;
         AffChg(cM^);
         AffNbCodes;

         ExCurY := ScreenHigh;
       End;
     End;
  until ResetAffCompo;
until true=false;
  InterProc := SaveProc;
end;


begin
  DirectVideo := FALSE;

  ChargeParam;
  InitSoft;
  InitCompo;
  If InitScr Then
   Begin
    Compose;
   End;

  EndProg;
  { le programme ne va pas jusqu'ici }
end.
